SoElapsedTime(3)

NAME
SoElapsedTime - The SoElapsedTime class is a controllable time source engine.

SYNOPSIS

#include <Inventor/engines/SoElapsedTime.h>

Inherits SoEngine.

  Public Member Functions
virtual SoType getTypeId (void) const
virtual const SoFieldData * getFieldData (void) const
virtual const SoEngineOutputData * getOutputData (void) const
SoElapsedTime (void)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void * createInstance (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFTime timeIn
SoSFFloat speed
SoSFBool on
SoSFBool pause
SoSFTrigger reset
SoEngineOutput timeOut

  Protected Member Functions
virtual ~SoElapsedTime (void)
virtual void writeInstance (SoOutput *out)

  Static Protected Member Functions
static const SoFieldData ** getInputDataPtr (void)
static const SoEngineOutputData ** getOutputDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoElapsedTime class is a controllable time source engine. The additional functionality provided by this engine versus just connecting to the realTime global field is the ability to control the speed of the time source plus logic to reset, stop and restart it.

Simple usage example, combined with SoComposeRotation:

#Inventor V2.1 ascii
Separator {
   Transform {
      rotation =
      ComposeRotation { axis 0 1 0  angle =
         ElapsedTime { }.timeOut
      }.rotation
   }
   Cube { }
}

See also
    SoTimeCounter

Constructor & Destructor Documentation

  SoElapsedTime::SoElapsedTime (void)
Default constructor.

  SoElapsedTime::~SoElapsedTime (void) [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoElapsedTime::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoElapsedTime::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoElapsedTime::getInputDataPtr (void) [static], [protected]
Returns the SoFieldData class which holds information about inputs in this engine.

  const SoEngineOutputData ** SoElapsedTime::getOutputDataPtr (void) [static], [protected]
Returns the SoEngineOutputData class which holds information about the outputs in this engine.

  const SoFieldData * SoElapsedTime::getFieldData (void) const [virtual]
Returns the SoFieldData class which holds information about inputs in this engine.

Reimplemented from SoFieldContainer.

  const SoEngineOutputData * SoElapsedTime::getOutputData (void) const [virtual]
Returns the SoEngineOutputData class which holds information about the outputs in this engine.

Implements SoEngine.

  void * SoElapsedTime::createInstance (void) [static]
Creates a new instance of the class type corresponding to the SoType object.

  void SoElapsedTime::writeInstance (SoOutput * out) [protected], [virtual]
Writes all the fields contained in this instance to the output stream within out.

This method is solely called from the write methods of fields.

Either from SoField if the write is done because of a field-to-field connection, or from one of the fields which may actually write SoFieldContainer instances, i.e. SoSFNode, SoMFNode, SoSFEngine, SoMFEngine, SoSFPath and SoMFPath.

This method, in addition to the ordinary write() method of SoNode, needs to be present since the fields don't have a write action instance in their writeValue() method, and writeInstance() will create a new SoWriteAction and call continueToApply() on it.

Reimplemented from SoEngine.

Member Data Documentation

  SoSFTime SoElapsedTime::timeIn
Input time value. Default connected to the global realTime field.

  SoSFFloat SoElapsedTime::speed
Decides how fast the timer should run, measured versus 'real time' from the timeIn field. Default value is 1.0.

A negative value makes the time go backward.

  SoSFBool SoElapsedTime::on
Shuts timer on and off. Will restart at the same position.

  SoSFBool SoElapsedTime::pause
Shuts timer on and off. Will restart at the position it would have been if not paused (i.e. doesn't 'lose time').

  SoSFTrigger SoElapsedTime::reset
Restart timer at 0.

  SoEngineOutput SoElapsedTime::timeOut
(SoSFTime) Output time value. Starts at 0.

Author

Generated automatically by Doxygen for Coin from the source code.